% Demonstrates computing of the range of affected coefficients by an edit
% in the signal domain

clc

%% inputs
n = 32:43 % indexes of the edited sample(s) - single or interval
depth = 3  %depth of decomposition
fillen = 4  %filter length


%% determining interval bounds
n_min = min(n);
n_max = max(n);


%% computing the range of affected coefficients
for cnt = 1:depth
    k_min(cnt) = ceil(n_min/2^cnt);
    k_max(cnt) = floor((n_max+(2^cnt-1)*(fillen-1))/2^cnt);
end


%% print out (level by level)
disp(' ')
disp('Indexes of the afected coefs, level by level:')
k_min
k_max