function demo_effect_of_boundary_handling_on_coefficients
% illustration of how many coefficients are affected by boundary handling


% N = 22;
N = 187+64*2;
% N = 93;
signal = zeros(N,1);
sampling_parity = 0; % default
% wavelet = 'db4';
wavelet = 'bior2.4';
[Lo_D, Hi_D] = wfilters(wavelet,'d');
[Lo_R, Hi_R] = wfilters(wavelet,'r');
[Lo_D,Hi_D] = short_filt(Lo_D,Hi_D); %shortening of biorthogonalfilters to odd length
J = 5;
lengths = cell(J,1);
% signal_parity = parity(length(signal));

clc
close all

n_Lo = length(Lo_D)
n_Hi = length(Hi_D)


%% %% Forward part
figure
for j = 1:J
    %% extension by ones
    signal_ext = [ones(n_Lo-1,1); signal; ones(n_Lo-1,1)];
    
    %% convolution with the filter
    coef_Lo = conv(signal_ext,Lo_D);
    coef_Hi = conv(signal_ext,Hi_D);
    
    %% cropping of borders
    coef_Lo = coef_Lo((n_Lo):(end-n_Lo+1));
    coef_Hi = coef_Hi((n_Hi):(end-n_Hi+1));
    
    %% downsampling
    coef_Lo = downsample(coef_Lo,sampling_parity);
    coef_Hi = downsample(coef_Hi,sampling_parity);
    lengths{j} = length(coef_Lo);
    
    %% plot and print
    subplot(J,1,j)
    stem(coef_Lo)
    ylabel(['j=' num2str(j)])
    axis tight
    %manual counting and print out
    disp(['Number of nonzero coefs at depth j=' num2str(j) ': '...
        num2str(length(coef_Lo)-sum(coef_Lo==0)) ', from left ' num2str(n_affect_l(j,n_Lo)) ...
        ', from right ' num2str(kolik_zprava_nenulovych(coef_Lo))])
    
    %% transfer to the next level
    signal = coef_Lo;
end



%% %% Inverse part
%just a single nonzero coef is going to be inverted
dwtmode('zpd');
L = N; %bookkeeping generation
C = []; %coefficients
%generation of coefficients
for j = 1:J %:-1:1
    coef = zeros(lengths{j},1);
    
    C = [coef; C];
    L = [lengths{j} L]; %bookkeeping generation
end
% last depth
coef = zeros(lengths{j},1);
coef(n_affect_l(J,n_Lo)) = 1; %single one
C = [coef; C];
L = [lengths{j} L]; %bookkeeping generation

%inversion
signal_rec = waverec(C,L,Lo_R,Hi_R);
figure
stem(signal_rec)
max(find(signal_rec)) % index of the last nonzero value


%%%%%%%%%%%%% inner fctions %%%%%
function [count] = kolik_zprava_nenulovych(vector)
% returns how many nonzero entries are in the vector, from the right
    vf = flipud(vector);
    count = 0;
    cnt = 1;
    while vf(cnt) ~= 0
        count = count + 1;
        cnt = cnt + 1;
    end