% Computes the number of wavelet coefficients unaffected by the boundary
% handling method
% (zero or negative values mean that ALL wavelet coefs are actually affected)


clc
clear unaffected


%% inputs
siglen = 80:7:180  %various signal lengths
fillen = 12  %filter length - single value!
depth = 2:4  %various decomposition depths


%% computing
for cnt_s = 1:length(siglen)
    for cnt_d = 1:length(depth)
        no_of_unaffected(cnt_d,cnt_s) = ...
        n_coef(siglen(cnt_s),fillen,depth(cnt_d)) - (2 * n_affect_l(depth(cnt_d), fillen) + 1);
    end
end

%% print results
no_of_unaffected  % prints the result in a table (horizontally siglen, vertically depth)