function dec = downsample(vec,sampling_parity)

% DOWNSAMPLE downsamples the input vector, i.e. leaves every other sample
%
% vec..................the input vector
% sampling_parity......the parity of downsampling
%                      0 (default).... even, e.g.  downsample(1:5) -> [2 4]
%                      1.............. odd, e.g.   downsample(1:5) -> [1 3 5]
%
% dec..................downsampled vector

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


%% check of params
if nargin == 1
    sampling_parity = 0;
end
% %vector orientation
% [rows, cols] = size(vec);
% 
% %% memory allocation
% vec_parity = parity(length(vec));
% % a bit complicated formula for the resultant length, but it includes all
% % possible combinations of parameters in one
% len = (length(vec)/2) - vec_parity/2 + vec_parity*sampling_parity;
% dec = zeros(len,1);

%% assigning the entries
dec = vec((2-sampling_parity):2:length(vec));