function num = n_coef(siglen,fillen,depth)

%N_COEF computes the number of coefficients at a chosen depth produced by DWT
%The zero-padding or compatible type of extending the borders is assumed.
%The downsampling is even.
%
%num = n_coefs(siglen,fillen,depth)
%
% siglen.......length of input signal
% fillen.......length of filter
% depth........depth of decomposition
%
% num..........the number of coefficients (detail or approximation, not together!)

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


num = 2^(-depth)*siglen - (2^(-depth)-1)*(fillen-1);
num = floor(num);