function num = n_coef_total(siglen,fillen,depth)

%N_COEF_TOTAL computes the total number of coefficients produced by the DWT
%Zero-padding or a compatible type of extending the borders is assumed.
%The downsampling is even.
%
% siglen.......length of input signal
% fillen.......length of filter
% depth........depth of decomposition
%
% num..........the total number of coefficients (altogether)

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


num = 0;
%detail coefs
for j=1:(depth-1)
    num = num + n_coef(siglen,fillen,j);
end
% aproximation and detail coefs at the last level
num = num + 2*n_coef(siglen,fillen,depth);