function num = n_samp(q, depth, fillen)

%N_SAMP returns the number of signal samples necessary for computation of
% q subsequent wavelet coefficients.
%
% q............number of subsequent wavelet coefficients
% fillen.......length of filter
% depth........depth of decomposition
%
% num..........number of samples in the time-domain

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


num = (2^(depth)-1)*(fillen-2) + 2^depth*q;