function num = n_shared(k1, k2, level_from, level_to, fillen)

% N_SHARE returns the number of shared coefficients
%
% k1, k2...................indices of the wavelet coefficients (k1<k2)
% level_from, level_to.....decomposition levels of interest;
%                          k1 and k2 are indices at level_from
% fillen.......length of filter
%
% num..........number of shared coefficients
%              (or time-domain samples if level_to = 0)

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


differ = level_from - level_to;
q = k2-k1-1;
num = (2^differ-1)*(fillen-2) - 2^differ*q;
num = max(0,num);