function [Lo_new,Hi_new] = short_filt(Lo,Hi)

% SHORT_FILT shortens biorthogonal filters. An auxiliary function.
%
% Modifies bior filters from the Matlab Wavelet Toolbox so that it cuts off
% the first zero (as Matlab always works with filters of even lenghts and we
% would like to demonstrate that everything works also with odd lengths).
%
% It is assumed that the "effective" length of Lo_D is greater then of Hi_D.
%
% Lo,Hi...........original filters
% Lo_new,Hi_new...filters (possibly) shortened to odd length

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


% n = length(Lo);

if Lo(1) == 0
    cut = 1;
else
    cut = 0;
end

Lo_new = Lo((1+cut):end);
Hi_new = Hi((1+cut):end);