% Batch testing the correctness of results
% in comparison to Matlab Wavelet toolbox

clear all
clc

%zero-padding for comparison purposes
dwtmode('zpd')

%signal
s = 507;
signal = randn(s,1);

%decomp. depth
J = 3;

%wavelet used
wname = 'db5';
% wname = 'bior6.8';

%subsampling parity
%must be 0 for orthogonal filters and 1 for biortho in order to get
%identical coefficients (the inversion is always the same)
subsampling_parity = 0;


%% filters
[Lo_D, Hi_D, Lo_R, Hi_R] = wfilters(wname); %calling the matlab wavelet toolbox
% for the biortho case
% also could be done by: [Lo_D_short, Hi_D_short, Lo_R_short, Hi_R_short] = w_filters(wname); 
[Lo_D_short,Hi_D_short] = short_filt(Lo_D,Hi_D);
[Lo_R_short,Hi_R_short] = short_filt(Lo_R,Hi_R);


%% forward
[C,L] = mldwt(signal, J, Lo_D_short, Hi_D_short, subsampling_parity);
[Cm,Lm] = wavedec(signal, J, Lo_D, Hi_D); %one cannot choose subsampling type here!
L, Lm
C(1:20,:)
Cm(1:20)


%% inverse
signal_rec = mlidwt(C, L, Lo_R_short, Hi_R_short, subsampling_parity);
signal_rec_m = waverec(Cm, Lm, Lo_R, Hi_R); %one cannot choose subsampling type here!
norm_of_difference = norm(signal_rec - signal_rec_m')