% Testing the DWTMATRIX function
% calls Matlab Wavelet toolbox functions for comparison purposes

clc; clear all; close all;
dwtmode('per');
mult = 5;

%% example 1
J = 8;
len = mult*2^J;
x = rand(len,1); % signal
[lo, hi] = w_filters('db10');

%undecimated case
coef = swt(x,J,[lo],[hi]); %calls WT from the Matlab toolbox
[W,y] = dwtmatrix(lo,hi,J,x,'undec');
y = W*x;
ctem = flipud(coef)';
norm(y-ctem(:))

%decimated case
coef = wavedec(x,J,[lo],[hi]); %calls WT from the Matlab toolbox
[W,y] = dwtmatrix(lo,hi,J,x);
norm(y-coef(:))



%% example 2
J = 3;
len = mult*2^J;
x = rand(len,1);

[lo, hi] = w_filters('bior6.8');
% [lo, hi] = w_filters('bior2.2');

%undecimated case
coef = swt(x,J,[0,lo],[0,hi]); %calls WT from the Matlab toolbox
[W,y] = dwtmatrix(lo,hi,J,x,'undec');
ctem = flipud(coef)';
norm(y-ctem(:))

%decimated case
coef = wavedec(x,J,[0,lo],[0,hi]); %calls WT from the Matlab toolbox
[W,y] = dwtmatrix(lo,hi,J,x);
norm(y-coef(:))