function ups = upsample(vec,sampling_parity)


% UPSAMPLE upsamples the input vector, i.e. inserts zeros inbetween entries
%
% vec..................the input vector
% sampling_parity......the parity of upsampling
%                      0 (default)... even, e.g. upsample(1:2) -> [1 0 2]
%                      1............. odd, e.g.  upsample(1:2) -> [0 1 0 2 0]
%
% ups..................upsampled vector

%(c) 2010-12 Pavel Rajmic, Brno University of Technology, Czech Republic


%% check of params
if nargin == 1
    sampling_parity = 0;
end
%vector orientation
[rows, cols] = size(vec);

%% memory allocation
len = 2*length(vec)+(-1)^(1-sampling_parity);
if rows >= cols
    ups = zeros(len,1);
else
    ups = zeros(1,len);
end

%% assigning the entries
ups((1+sampling_parity):2:length(ups)) = vec;